function sincd_interpol_demo_CRC
INP=dct([t_rand(1,4)-0.5,zeros(1,12)]);
s=menu('Select subsampling rate','2','3','4','5','6');
Lx=s+1;
OUTP=sincint_CRC(INP,Lx);
%------------------------------------------------------------
function OUTP=sincint_CRC(INP,Lx);

% 1-D discrrete sinc interpolation with Lx-fold signal subsampling
% (SzX/2+1)th sample of the shifting filter frequency response is equal to cos(pi/Lx);
% 
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTP=sincint_CRC(INP,Lx);

SzX =max(size(INP));
INP=reshape(INP,SzX,1);
OUTP=zeros(Lx*SzX,1);
figure(1);
stem(INP,'r.','LineWidth',2);
Ux=1/(Lx);
M=zeros(SzX,1);
M(1)=1; M((SzX/2)+1)=exp(i*pi*Ux);
r=2:SzX/2; Wn=i*2*pi*Ux/SzX;
M(r)=exp(Wn*(r-1)); M(SzX+2-r)=conj(M(r));
spinput=fftnorm(INP);

ss=['+','*','.','x','o','^','v','<','>'];
sss=[{'Init. samples, Shift0'},{'Shift1'},{'Shift2'},{'Shift3'},{'Shift4'},{'Shift5'},{'Shift6'},{'Shift7'}];
LW=[3,2,2,2,2,2,2,2,2];
TTL=[{'Initial samples: shift0'},{'Interpolated samples: shift1'},{'Interpolated samples: shift2'},{'Interpolated samples: shift1'},.......
    {'Interpolated samples: shift3'},{'Interpolated samples: shift4'},{'Interpolated samples: shift5'},.........
    {'Interpolated samples: shift6'},{'Interpolated samples: shift7'}];

for l=1:Lx,
    spinput=spinput.*M;
    out=real(ifftnorm([spinput(1:SzX/2);real(spinput(SzX/2+1));spinput(SzX/2+2:SzX)]));
	key=zeros(Lx,1);key(l)=1;
	OUTP=kron(out,key)+OUTP;
    stem(kron(out,key),ss(l),'LineWidth',LW(l));axis tight;grid
    hold on
    title([TTL(l)],'FontWeight','Bold','FontSize',10);
    drawnow;
    pause(1);
end
legend(sss(1:Lx),'FontWeight','Bold');
set(gca,'FontWeight','Bold','FontSize',10);
hold off
%-----------------------------------------------------------------------
function OUT=t_rand(SzX,SzY)

% Generating uniformly distributed random numbers with seed taken
% clock at the moment the program is called
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUT=t_rand(SzX,SzY)


time = clock;
seed = time([6]);
rand('seed',seed);

OUT=rand(SzX,SzY);


	